'=========================================
' BCL program to use the Barionet itself as Modbus/RTU slave
' The modbus address will be the last segment of the IP address.
' For the serial connection to Modbus master the serial RS232 interface of the Barionet must be used.
'=========================================

DIM com$(16)
DIM ms$(129)
DIM mr$(128)
DIM m$(128)
DIM crc
DIM mlen,mba,mbok,cmd,reg,num,value
DIM a,i,j,k,u,x,i2000
DIM name$(20)
DIM rport, rhost$(20),p$



name$ = sprintf$("%1A",1)
SYSLOG "Start Barionet as Modbus/RTU slave on "+name$ + " Version 1.00", 1
name$ = mid$(name$,13,3)
MBA=VAL(name$)
SYSLOG " Local Modbus Address = " + STR$(MBA)

com$ = "COM::1"
OPEN com$ as 4				' open RS232 interface
SYSLOG "RS-232 Port Open", 1

'-------------------------------------------------------------------
100 'Main program
'-------------------------------------------------------------------
DELAY 100  
GOSUB 400 'checks for incoming request
IF mbok=1 THEN
    IF mba = MIDGET(mr$,1,1) THEN
          cmd=MIDGET(mr$,2,1)				' extract Modbus command
	  reg=(256*MIDGET(mr$,3,1))+MIDGET(mr$,3+1,1)	' extract register number
	  num=(256*MIDGET(mr$,5,1))+MIDGET(mr$,5+1,1)	' extract number of requested registers
	  MIDSET ms$, 1, 1, mba 			' set Modbus address for response
  	  MIDSET ms$, 2, 1, cmd   			' set Modbus command for response
	  mlen=3
          IF AND(cmd=2,reg<400) THEN   			' check for one bit registers & Modbus command 2
            FOR u = 1 to num
              value=IOSTATE(reg+u)              	' +1 , because of converting Modbus register to Barionet register
	      MIDSET ms$, 3+u, 1, value
              mlen=mlen+1
	    NEXT u
            ELSE
	     IF AND(cmd=3,reg>=500) THEN   		' check for 16 bit registers & Modbus command 3
          	FOR u = 1 to num
            	  value=IOSTATE(reg+u)              	' +1 , because of converting Modbus register to Barionet register
	  	  MIDSET ms$, 4+(2*(u-1)), -2, value
          	  mlen=mlen+2
		NEXT u
                ELSE
                ms$ ="request not supported"		' other commands als Modbus command 2 & 3 are not supported
		SYSLOG ms$
		WRITE 4, ms$, 21
		GOTO 100
	     ENDIF
           ENDIF
	   MIDSET ms$, 3, 1, mlen-3 			' data length
	   mlen=mlen+2 					' 2 more because of CRC
	   GOSUB 2000					' goto to CRC section
	   WRITE 4, ms$, mlen
	   GOSUB 700					' cleans up the serial line
	   GOSUB 3000					' jumps to section for SYSLOG Modbus debugging
     ENDIF
ENDIF

GOTO 100						' restart main loop
END


'------------------------------------------------------------------------
400 'read request
'------------------------------------------------------------------------
 
  READ 4,mr$,40		 				' try to read
  mlen=LASTLEN(4)
  IF mlen<>0 THEN
    a=1							' marker for read SYSLOG message
    GOSUB 3000     					' sends Modbus response as SYSLOG for debugging 
    crc=&HFFFF
    FOR i2000=1 TO mlen-2 				' check Modbus CRC from response
	crc=xor(crc,MIDGET(mr$,i2000,1))
	IF AND(crc,1) THEN crc=xor(crc,&H14002)
	IF AND(crc,2) THEN crc=xor(crc,&H28004)
	IF AND(crc,4) THEN crc=xor(crc,&H50008)
	IF AND(crc,8) THEN crc=xor(crc,&HA0010)
	IF AND(crc,16) THEN crc=xor(crc,&H140020)
   	IF AND(crc,32) THEN crc=xor(crc,&H280040)
   	IF AND(crc,64) THEN crc=xor(crc,&H500080)
   	IF AND(crc,128) THEN crc=xor(crc,&HA00100)
   	crc=SHR(crc,8)
    NEXT i2000
    SYSLOG "CRC = "+ STR$(crc)		 
    IF MIDGET(mr$,mlen-1,2)<>crc THEN
      SYSLOG "read: crc error"
      mbok=-2
          ELSE
            mbok=1					' when CRC is ok, set mbok=1
   	ENDIF
        ELSE
'         SYSLOG "no modbus request " , 5
          mbok=-1
    ENDIF
RETURN

'------------------------------------------------------------------------
700 'check/clean up RS485 line before writing
'------------------------------------------------------------------------
  READ 4, m$
  RETURN


'------------------------------------------------------------------------
2000 'Modbus CRC calc
'------------------------------------------------------------------------
  crc = &HFFFF
  FOR i = 1 TO (mlen-2)
    crc = XOR(crc, MIDGET(ms$, i, 1))
    FOR j = 1 TO 8
      k = AND(crc, 1)
      crc = SHR(crc, 1)
      IF k = 1 THEN crc = XOR(crc, &HA001)
    NEXT j
  NEXT i        
  MIDSET ms$, (mlen - 1), 2, crc
RETURN

'------------------------------------------------------------------------
3000 ' SYSLOG DEBUGGING for MODBUS communication
'------------------------------------------------------------------------
  IF a=1 THEN						' a=1 is "read" , a=0 is "write"
    p$=SPRINTF$("read: %d bytes: ",mlen)		' prepare response for SYSLOG
    FOR x=1 TO mlen 
      p$=p$+SPRINTF$(" %02x",MIDGET(mr$,x,1)) 		' prepare response/command for SYSLOG
    NEXT x
    ELSE
       p$=SPRINTF$("write: %d bytes: ",mlen)		' prepare response for SYSLOG
       FOR x=1 TO mlen 
	 p$=p$+SPRINTF$(" %02x",MIDGET(ms$,x,1)) 	' prepare response/command for SYSLOG
       NEXT x
  ENDIF
  SYSLOG p$, 6						' syslog Modbus response string
  a=0
RETURN
